# exos_command – Run commands on remote devices running Extreme EXOS

New in version 2.6.

- Synopsis

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Sends arbitrary commands to an Extreme EXOS device and returns the results read from the device. This module includes an argument that will cause the module to wait for a specific condition before returning or timing out if the condition is not met.

- This module does not support running configuration commands. Please use exos_config to configure EXOS devices.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
commands - / required |  | List of commands to send to the remote EXOS device over the configured provider. The resulting output from the command is returned. If the wait_for argument is provided, the module is not returned until the condition is satisfied or the number of retries has expired.
interval - | Default: 1 | Configures the interval in seconds to wait between retries of the command. If the command does not pass the specified conditions, the interval indicates how long to wait before trying the command again.

match
-

Choices:
- any
- all ←

The match argument is used in conjunction with the wait_for argument to specify the match policy. Valid values are `all` or `any`. If the value is set to `all` then all conditionals in the wait_for must be satisfied. If the value is set to `any` then only one of the values must be satisfied.

retries - | Default: 10 | Specifies the number of retries a command should by tried before it is considered failed. The command is run on the target device every retry and evaluated against the wait_for conditions.
wait_for - |  | List of conditions to evaluate against the output of the command. The task will wait for each condition to be true before moving forward. If the conditional is not true within the configured number of retries, the task fails. See examples.

## Notes

Note

- If a command sent to the device requires answering a prompt, it is possible to pass a dict containing command, answer and prompt. See examples.

## Examples

    tasks:
      - name: run show version on remote devices
        exos_command:
          commands: show version
      - name: run show version and check to see if output contains ExtremeXOS
        exos_command:
          commands: show version
          wait_for: result[0] contains ExtremeXOS
      - name: run multiple commands on remote nodes
        exos_command:
          commands:
            - show version
            - show ports no-refresh
      - name: run multiple commands and evaluate the output
        exos_command:
          commands:
            - show version
            - show ports no-refresh
          wait_for:
            - result[0] contains ExtremeXOS
            - result[1] contains 20
      - name: run command that requires answering a prompt
        exos_command:
          commands:
            - command: 'clear license-info'
              prompt: 'Are you sure.*'
              answer: 'Yes'

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
failed_conditions list | failed | The list of conditionals that have failed Sample: ['...', '...']
stdout list | always apart from low level errors (such as action plugin) | The set of responses from the commands Sample: ['...', '...']
stdout_lines list | always apart from low level errors (such as action plugin) | The value of stdout split into a list Sample: [['...', '...'], ['...'], ['...']]

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Rafael D. Vencioneck (@rdvencioneck)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.